//
//      SGXAWSParser.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#ifndef __SGXAWSPARSER_HPP
#define __SGXAWSPARSER_HPP

#include <SophiaFramework.hpp>


SFMTYPEDEFSTRUCT(ItemAttributesRec)
struct ItemAttributesRec {
	SFXAnsiString binding;
	SFXProperty creator;
	SInt32 amount;
	SFXAnsiString currencyCode;
	SFXAnsiString formattedPrice;
	SInt32 numberOfPages;
	SInt32 packageDimensionsLength;
	SInt32 packageDimensionsWidth;
	SFXAnsiString productGroup;
	SFXDate publicationDate;
	SFXAnsiString publisher;
};


SFMTYPEDEFSTRUCT(ImageUrlRec)
struct ImageUrlRec {
	SFXAnsiString smallImageURL;
	SInt32 smallImageHeight;
	SInt32 smallImageWidth;
	SFXAnsiString mediumImageURL;
	SInt32 mediumImageHeight;
	SInt32 mediumImageWidth;
	SFXAnsiString largeImageURL;
	SInt32 largeImageHeight;
	SInt32 largeImageWidth;
};

SFMTYPEDEFSTRUCT(OfferSummaryRec)
struct OfferSummaryRec {
	SInt32 lowestNewPrice;
	SFXAnsiString currencyCode;
	SFXAnsiString formattedPrice;
	SInt32 totalNew;
	SInt32 totalUsed;
	SInt32 totalCollectible;
	SInt32 totalRefurbished;
};

SFMTYPEDEFSTRUCT(OfferRec)
struct OfferRec {
	SFXAnsiString merchantId;
	SFXAnsiString condition;
	SFXAnsiString offerListingId;
	SInt32 amount;
	SFXAnsiString CurrencyCode;
	SFXAnsiString formattedPrice;
};

SFMTYPEDEFSTRUCT(OffersRec)
struct OffersRec {
	SInt32 totalOffers;
	SInt32 totalOfferspages;
	SFXArray<OfferRecPtr> offers;
};

SFMTYPEDEFSTRUCT(ReviewRec)
struct ReviewRec {
	SFXAnsiString asin;
	SInt32 rating;
	SInt32 helpfulVotes;
	SFXAnsiString customerId;
	SInt32 totalVotes;
	SFXDate date;
	SFXAnsiString summary;
	SFXAnsiString content;
};

SFMTYPEDEFSTRUCT(CustomerReviewsRec)
struct CustomerReviewsRec {
	SInt32 avarageRating;
	SInt32 totalReviews;
	SInt32 totalReviewPages;
	SFXArray<ReviewRecPtr> reviews;
};

SFMTYPEDEFSTRUCT(SimilarProductRec)
struct SimilarProductRec {
	SFXAnsiString asin;
	SFXAnsiString title;
};

SFMTYPEDEFSTRUCT(SimilarProductsRec)
struct SimilarProductsRec {
	SFXArray<SimilarProductRecPtr> similarProducts;
};
  
SFMTYPEDEFSTRUCT(BrowserNodesRec)
struct BrowserNodesRec {
	SFXAnsiString dummy;
	// Not yet implimentation.
};

SFMTYPEDEFSTRUCT(ListmaniaListsRec)
struct ListmaniaListsRec {
	SFXAnsiString dummy;
	// Not yet implimentation.
};

//AWS(Amazon Web Services)  XML X|X͂NX
SFMTYPEDEFCLASS(SGXAWSParser)
class SGXAWSParser {
SFMSEALCOPY(SGXAWSParser)
public:
private:
    // ItemAttributes ̃^Ỏ͂邩ǂ
    Bool _isParseItemAttributes;
    // SmallImage ̃^Ỏ͂邩ǂ
    Bool _isParseImageUrl;
    Bool _isParseOfferSummary;
    Bool _isParseOffers;
    Bool _isParseCustomerReviews;
    Bool _isParseSimilarProducts;
    Bool _isParseBrowserNodes;
    Bool _isParseListmaniaLists;

    SFXAnsiString _asin;
    SFXAnsiString _detailPageURL;
    SInt32 _salesRank;
    SFXAnsiString _title;
	SFXSOAPRPC _rpc;

	// ߖ̂߃|C^ƂĕێB
    ItemAttributesRecPtr _itemAttributes;
    ImageUrlRecPtr _imageUrl;
    OfferSummaryRecPtr _offerSummary;
    OffersRecPtr _offers;
    CustomerReviewsRecPtr _customerReviews;
    SimilarProductsRecPtr _similarProducts;
    BrowserNodesRecPtr _browserNodes;
    ListmaniaListsRecPtr _listmaniaLists;

public:
    SGXAWSParser(Void);
    virtual ~SGXAWSParser(Void);
    Void SetParseItemAttributes(Bool param) { _isParseItemAttributes = param; }
    Void SetParseImageUrl(Bool param) { _isParseImageUrl = param; }
    Void SetParseOfferSummary(Bool param) { _isParseOfferSummary = param; }
    Void SetParseOffers(Bool param) { _isParseOffers = param; }
    Void SetParseCustomerReviews(Bool param) { _isParseCustomerReviews = param; }
    Void SetParseSimilarProducts(Bool param) { _isParseSimilarProducts = param; }
    Void SetParseBrowserNodes(Bool param) { _isParseBrowserNodes = param; }
    Void SetParseListmaniaLists(Bool param) { _isParseListmaniaLists = param; }
    Bool IsParseItemAttributes(Void) { return _isParseItemAttributes; }
    Bool IsParseImageUrl(Void) { return _isParseImageUrl; }
    Bool IsParseOfferSummary(Void) { return _isParseOfferSummary; }
    Bool IsParseOffers(Void) { return _isParseOffers; }
    Bool IsParseCustomerReviews(Void) { return _isParseCustomerReviews; }
    Bool IsParseSimilarProducts(Void) { return _isParseSimilarProducts; }
    Bool IsParseBrowserNodes(Void) { return _isParseBrowserNodes; }
    Bool IsParseListmaniaLists(Void) { return _isParseListmaniaLists; }
public:
    SFXAnsiStringConstRef GetAsin(Void) { return _asin; }
    SFXAnsiStringConstRef GetDetailPageURL(Void) { return _detailPageURL; }
    SInt32 GetSalesRank(Void) { return _salesRank; }
    SFXAnsiStringConstRef GetTitle(Void) { return _title; }

    ItemAttributesRecConstPtr GetItemAttributes(Void) { return _itemAttributes; }
    ImageUrlRecConstPtr GetImageUrl(Void) { return _imageUrl; }
    OfferSummaryRecConstPtr GetOfferSummary(Void) { return _offerSummary; }
    OffersRecConstPtr GetOffers(Void) { return _offers; }
    CustomerReviewsRecConstPtr GetCustomerReviews(Void) { return _customerReviews; }
    SimilarProductsRecConstPtr GetSimilarProducts(Void) { return _similarProducts; }
    BrowserNodesRecConstPtr GetBrowserNodes(Void) { return _browserNodes; }
    ListmaniaListsRecConstPtr GetListmaniaLists(Void) { return _listmaniaLists; }

	SFCError SGXAWSParser::ParseSOAP(SFXXMLElementPtr root);
    Void Clear();
	SFCError ParseItemAttributes(SFXXMLNodePtr node);
    SFCError ParseTitle(SFXXMLNodePtr node);
    SFCError ParseSmallImage(SFXXMLNodePtr node);
    SFCError ParseMediumImage(SFXXMLNodePtr node);
    SFCError ParseLargeImage(SFXXMLNodePtr node);
    SFCError ParseOfferSummary(SFXXMLNodePtr node);
    SFCError ParseOffers(SFXXMLNodePtr node);
    SFCError ParseCustomerReviews(SFXXMLNodePtr node);
    SFCError ParseSimilarProducts(SFXXMLNodePtr node);
    SFCError ParseBrowserNodes(SFXXMLNodePtr node);
    SFCError ParseListmaniaLists(SFXXMLNodePtr node);
};

#endif // __SGXAWSPARSER_HPP //
